/////////////////////////////////////////////////////////////////////////////////////////
//C30_dsPIC30F3014Def.h
//Written By Kenichi OHARA, Arai Lab, Osaka University
/////////////////////////////////////////////////////////////////////////////////////////
#include <p30f3014.h>
#include <uart.h>
#include <adc12.h>
#include <stdio.h>
/////////////////////////////////////////////////////////////////////////////////////////
//RtBO[Vrbg̐ݒ
/////////////////////////////////////////////////////////////////////////////////////////
//NbNݒ
_FOSC( XT_PLL8 );      				//UH*8{̃NbNœ
//EHb`hbN^C}ݒ
_FWDT(WDT_OFF);
//BOR,PORݒ
_FBORPOR( MCLR_EN & PBOR_OFF & PWRT_64);

/////////////////////////////////////////////////////////////////////////////////////////
//}Nݒ
/////////////////////////////////////////////////////////////////////////////////////////
#define CPU_CLOCK          10000000                   //Clock  
#define CLOCK_FREQUENCY    ( ( CPU_CLOCK * 8 ) / 4 )  //g
#define BAUDRATE           115200L                    //VAʐM̃{[[g

//*****************************************************
//^`
//*****************************************************
#define BYTE				unsigned char

/////////////////////////////////////////////////////////////////////////////////////////
//֐`
//Œ`Ă֐͋ʊ֐D
//RpCɉĒ`̈قȂ֐ɑ΂郉bpD
/////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************
//
//*****************************************************
void DeviceInitialize();
void Delay1ms();

//*****************************************************
//񑗐M֌W
//*****************************************************
void SendMessage(const char *string);
void SendCharacter(const char string);

//*****************************************************
//EEPROMǂݏo֐
//*****************************************************

//*****************************************************
//ADf[^ǂݏo֐
//*****************************************************
unsigned short GetADData();

//*****************************************************
//DIOo͊֐
//*****************************************************
void OutputPort(unsigned char bitdata);

/////////////////////////////////////////////////////////////////////////////////////////
//֐{
/////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************
//foCX̏
//*****************************************************
void DeviceInitialize(){
//=====================================================
//|[g̓o͂̐ݒ
//=====================================================
	//VAʐM֘A
	LATC=0x0000;
	TRISCbits.TRISC13 = 0;			//ATX|[go͂
	TRISCbits.TRISC14 = 1;			//ARX|[g͂
	//DIOo͊֘A
	LATD=0x0000;
	TRISDbits.TRISD0  = 0;			//PD0-3o͂
	TRISDbits.TRISD1  = 0;
	TRISDbits.TRISD2  = 0;
	TRISDbits.TRISD3  = 0;
//=====================================================
//A/Dϊ̐ݒ
//=====================================================
	const unsigned int Config1
         = ADC_MODULE_ON            			// ADW[ - ON
         & ADC_IDLE_STOP            			// ACh[h - ~
         & ADC_FORMAT_INTG          			// f[^o͌` - 
         & ADC_CLK_AUTO             			// ϊgKv - 
         & ADC_AUTO_SAMPLING_OFF    			// Tv - OFF
         & ADC_SAMP_OFF;            			// TvJn - OFF
    
	const unsigned int Config2
         = ADC_VREF_AVDD_AVSS       			// t@Xd - Vdd:Vss
         & ADC_SCAN_OFF             			// XL - OFF
         & ADC_SAMPLES_PER_INT_1    			// 荞݃^C~O - Tv
         & ADC_ALT_BUF_OFF          			// obt@[h - obt@1gp
         & ADC_ALT_INPUT_OFF;       			// ݓ̓Tv[h - OFF
         
	const unsigned int Config3
         = ADC_CONV_CLK_SYSTEM      			// NbN - VXe NbN
         & ADC_SAMPLE_TIME_4        			// Tv - 4 ( 4 x TAD )
         & ADC_CONV_CLK_16Tcy;      			// ADϊNbN - 16 ( 80MHz x 16 = 400nsec )
        
	const unsigned int ConfigPort   			// AiO sw
         = ENABLE_AN0_ANA;
    
	// AiO s̓[hɂ
    TRISBbits.TRISB0 = 1;  
    
    const unsigned int ConfigScan = SCAN_NONE;	// V[PV XL - 


    // 12rbgADRo[^ 샂[hݒ肷
    OpenADC12( Config1, Config2, Config3, ConfigPort, ConfigScan );

//=====================================================
//VAʐM̐ݒ
//=====================================================
	//UART̓샂[hݒ
    const unsigned int UARTMode
         = UART_EN              	//UARTgp
         & UART_IDLE_STOP       	//ACh[hF~
         & 0xFFE7     				//ARX_ATXsgpUARTŎgp
         & UART_DIS_WAKE        	// EFCNAbv - 
         & UART_DIS_LOOPBACK    	// [vobN - 
         & UART_DIS_ABAUD       	// {[[g - 
         & UART_NO_PAR_8BIT     	// peBȂ^f[^ 8rbg
         & UART_1STOPBIT;       	// Xgbvrbg 1rbg
    
    //UART̏Ԑݒ
    const unsigned int UARTStatus
         = UART_INT_TX_BUF_EMPTY    // M^C~O - Mobt@
         & UART_TX_PIN_NORMAL       // u[NM - ʏ
         & UART_TX_ENABLE           // M - L
         & UART_INT_RX_CHAR         // M^C~O - Msx
         & UART_ADR_DETECT_DIS      // AhXo - 
         & UART_RX_OVERRUN_CLEAR;   // Mobt@ I[o[G[ - NA

	//UART̒ʐMxvZ
    const double UARTBaudrate = (double)CLOCK_FREQUENCY / ( 16 * BAUDRATE ) - 1;
 
	//XPort̋N҂EFCg
	Delay1ms();
	
    //UART̃|[gI[v
    OpenUART1( UARTMode, UARTStatus, (unsigned short)( UARTBaudrate + 0.5 ) );
    //VAM荞݃tONA
    IFS0bits.U1RXIF = 0;
    //UARTM荞݋         
	EnableIntU1RX;
}

void Delay1ms(){
	long j;
	for(j = 0; j < 5000000; j++){
	}    
}

//*****************************************************
//VAʐM֌W
//*****************************************************
//=====================================================
//f[^̑M
//=====================================================
void SendMessage(const char *string){
	printf(string);	
}

void SendCharacter(const char string){
	putchar(string);
}

//=====================================================
//VAM荞
//=====================================================
void __attribute__(( interrupt, auto_psv )) _U1RXInterrupt(){
    int temp;
     
    //1Byteǂݍ
    gBuffer[gNextIn] = ReadUART1();
    
    temp = gNextIn;
    
    //gNextInobt@𒴂Ăꍇlɓꂽ
    gNextIn = (gNextIn + 1) % BUFFER_SIZE;
    
    if(gNextIn == gNextOut){
		gNextIn = temp;
	}
	
    // 荞݃tONA
    IFS0bits.U1RXIF = 0;   
}

//*****************************************************
//ADf[^ǂݏo֐
//*****************************************************
unsigned short GetADData(){
    //AD0̃f[^ǂݍރ`l̐ݒ
    SetChanADC12(ADC_CH0_POS_SAMPLEA_AN0&ADC_CH0_NEG_SAMPLEA_NVREF);
	//ADϊX^[g
	ADCON1bits.SAMP =1;
	//ADϊI܂ő҂
	while(BusyADC12()){
    }
    return ReadADC12(0);	
}

//*****************************************************
//DIOo͊֐
//*****************************************************
void OutputPort(unsigned char bitdata){
	LATD = bitdata & 0x000F;
}

