///////////////////////////////////////////////////////////////////////////////
//rtc_message.h
//Written By Kenichi OHARA, Arai Lab, Osaka University
///////////////////////////////////////////////////////////////////////////////
#ifndef _RTC_MESSAGE_H_
#define _RTC_MESSAGE_H_

//*****************************************************************************
//Macro Definition
//*****************************************************************************
#define DATA_MAX			16
#define HEADER_LENGTH		4
#define PARITY_LENGTH		1
#define MESSAGE_MAX_LENGTH	21


/////////////////////////////////////////////////////////////////////////////////////////
//֐`
/////////////////////////////////////////////////////////////////////////////////////////
//*****************************************************
//f[^͗p֐
//*****************************************************
unsigned char 	bgetc();
void 			rtc_message_read();
int				rtc_message_parity_check();
unsigned int		rtc_message_get(int num);

//*****************************************************
//f[^o͗p֐
//*****************************************************
void			rtc_message_begin();
void			rtc_message_putc(BYTE data);
unsigned int		rtc_message_end();

//============================================================================
//Mpobt@̃f[^擾
//============================================================================
unsigned char bgetc(){
	unsigned char c;
	
	while(gNextIn == gNextOut){
	}
	c = gBuffer[gNextOut];
	gNextOut = (gNextOut + 1) % BUFFER_SIZE;
	return c;
}

//============================================================================
//bZ[W̓ǂݍ
//============================================================================
void rtc_message_read(){
	int 		index;
	long	timeout;
	unsigned char	c=0;
	
	index = 0;
	timeout=0;
	
	//wb_܂ŎMf[^XLbv
	while(1){
		c = bgetc();
		
		if(c == 0xFF){
			gMessageBegin = gNextOut - 1;
			index++;
			break;
		}
	}
	
	//ǂݍݗpobt@̃|C^i߂
	while(1){
		if(gNextIn != gNextOut){
			timeout = 0;
			c = bgetc();
			if(index < MESSAGE_MAX_LENGTH){
				index ++;
			}
		}
		timeout++;
		if(timeout>100){
			gMessageSize = index;	//Data size
			gMessageEnd  = (BUFFER_SIZE + gNextOut -1) % BUFFER_SIZE;
			break;
		}
		else{

		}
	}
}

//=====================================================
//f[^M֐
//Mf[^numԖڂ̃f[^擾
//=====================================================
unsigned int rtc_message_get(int num)
{
  return gBuffer[(gMessageBegin + num) % BUFFER_SIZE];
}

//=====================================================
//peB`FbN֐
//=====================================================
int rtc_message_parity_check(){
	int i;
	int parity = 0; //Mf[^̃peB`FbN
	int end_mark;   //peBf[^

	/*peBf[^̌vZ@iwb_͔ČvZj
   	 * Format:
   	 * |  0 |..............|size|
   	 * |0xFF|....data......| SUM|
   	 * SUM: parity of data field
   	*/
   
   	//peB̌vZ
   	for (i = 1; i < gMessageSize - 1; i++){
	   	parity ^= rtc_message_get(i);
	}
	end_mark = rtc_message_get(gMessageSize - 1);
	return (end_mark == parity) ? 1 : 0;
}

//*****************************************************
//f[^o͗p֐
//*****************************************************
//=====================================================
//wb_M֐
//=====================================================
void rtc_message_begin(){
	gOutMessage.sum = 0;
	gOutMessage.cnt = 0;
	SendCharacter(0xFF); 
	++gOutMessage.cnt;
}

//=====================================================
//f[^M֐
//=====================================================
void rtc_message_putc(BYTE data){
	SendCharacter(data);
	gOutMessage.sum ^= data;
	gOutMessage.cnt++;
}

//=====================================================
//Ghf[^M֐
//=====================================================
unsigned int rtc_message_end(){
	unsigned int cnt;
	SendCharacter(gOutMessage.sum);
	cnt = gOutMessage.cnt;
	gOutMessage.sum = 0;
	gOutMessage.cnt = 0;
	SendCharacter(0x0D);
	SendCharacter(0x0A);
	return cnt;
}
#endif

